;#########################################################################
;
;				WinGbt V2.8
;	             	   Game Boy Transfer V2.8
;		      Del Nero Jean Franois 	1998 - 2000
;			jeanfrancoisdelnero@libero.it
;			     www.powerofasm.fr.st
;				
;				Main Program
;	
;#########################################################################
;  
;#########################################################################

      .386
      .model flat, stdcall  ; 32 bit memory model
      option casemap :none  ; case sensitive

      include Win32Gbt.inc     ; local includes for this file
      include Gbtio.inc        ; I/o Routines 
      include bitmap.inc       ; background picture
      include info.inc         ; texte informations 
      include gbt32.inc        ; fonctions diverses 

; #########################################################################

.code

;#################################################################################
 ; /////Thread pour scroll image de fond
MainLoopProc PROC hWndc:DWORD
 LOCAL hProc:HANDLE
 LOCAL hThread:HANDLE
 invoke GetDC,hWndc
 mov myDC,eax
 invoke GetCurrentThread
 mov hThread,eax
 invoke GetCurrentProcess
 mov hProc,eax
 invoke SetPriorityClass,eax,IDLE_PRIORITY_CLASS
 mov eax,hThread
 invoke SetThreadPriority,eax,THREAD_PRIORITY_IDLE 

@@forever:
 call render
 push hWndc
 call DIB_Draw          ;/copie dans fenetre
;  bouclekk:
;  cmp ds:[UpdateInfo],0
;  je bouclekk
  not ds:[UpdateInfo]
 jmp @@forever
MainLoopProc ENDP

render proc
pushad
 mov esi,ds:[pointeurdessin];offset dessin + 1078
 mov edi,offset FrameBuffer
 mov ecx,64000
bouclerender:
 mov al,ds:[esi]
 mov ds:[edi],al
 inc esi
 cmp esi,offset dessin + 1078 +64000
 jne jpferf4 
 mov esi,offset dessin + 1078 
jpferf4:
 inc edi
 dec ecx
 jnz bouclerender
 mov eax,ds:[pointeurdessin]
 add eax,319
 cmp eax,offset dessin + 1078 + 64000  
jae super12
 mov ds:[pointeurdessin],eax 
 popad
 ret
super12:
 mov ebx,eax
 MOV EAX,offset dessin + 1078 + 64000
 sub ebx,eax
 MOV eax,offset dessin + 1078
 add eax,ebx
 mov ds:[pointeurdessin],eax
 popad
 ret
render endp

;#################################################################################

;### Fonction pour le rafraichissement periodique (presence interface/cartouche) ###

rafraichir proc
 pushad
 cmp ds:[Rafraichissement],0
je  finrafr
 cmp ds:[Transfer],0
jne finrafr

 call CHECKPRESENCE
 cmp al,1
je oksuitebffffd
 xor al,al
 mov ds:[DisplayName],al
jmp finloadcartd

oksuitebffffd:
 CALL VFASTCOPYBANK0
 call CHECKLOGO
 cmp al,1
je oksuiteafffd
 xor al,al
 mov ds:[DisplayName],al
jmp finloadcartd
oksuiteafffd:

 mov cx,20
 mov esi,offset BufferCartouche1 + 134h
 mov ebx,offset DisplayName
bouclenomfichd:
 mov al,ds:[esi]
 mov ds:[ebx],al
 inc ebx
 inc esi
 cmp al,0
je finbouclenomd
 dec cx
jnz bouclenomfichd
finbouclenomd:
 dec ebx
 mov al,0
 mov ds:[ebx],al
finloadcartd:
 invoke SetWindowText,hWnd,ADDR szDisplayName
finrafr:
popad
ret
rafraichir endp

;#####################################################################################

; ### Point d'entr 

start:
      invoke GetModuleHandle, NULL
      mov hInstance, eax

      invoke GetCommandLine
      mov CommandLine, eax

      invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
      invoke ExitProcess,eax

; #########################################################################

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

      ;====================
      ; Put LOCALs on stack
      ;====================

      LOCAL wc   :WNDCLASSEX
      LOCAL msg  :MSG
      LOCAL Wwd  :DWORD
      LOCAL Wht  :DWORD
      LOCAL Wtx  :DWORD
      LOCAL Wty  :DWORD

      ;==================================================
      ; Fill WNDCLASSEX structure with required variables
      ;==================================================

      invoke LoadIcon,hInst,500    ; icon ID
      mov hIcon, eax

      szText szClassName,"Project_Class"

      mov wc.cbSize,         sizeof WNDCLASSEX
      mov wc.style,          CS_HREDRAW or CS_VREDRAW \
                             or CS_BYTEALIGNWINDOW
      mov wc.lpfnWndProc,    offset WndProc
      mov wc.cbClsExtra,     NULL
      mov wc.cbWndExtra,     NULL
      m2m wc.hInstance,      hInst
      mov wc.hbrBackground,  COLOR_BTNFACE+1
      mov wc.lpszMenuName,   NULL
      mov wc.lpszClassName,  offset szClassName
      m2m wc.hIcon,          hIcon
      invoke LoadCursor,NULL,IDC_ARROW
      mov wc.hCursor,        eax
      m2m wc.hIconSm,        hIcon

      invoke RegisterClassEx, ADDR wc

      ;================================
      ; Centre window at following size
      ;================================

      mov Wwd, 330
      mov Wht, 210
      call CalcPalette 	; Palette background
      invoke OpenTVicPort ; initialisation driver TVicPort
      invoke IsDriverOpened
      test eax,eax
      jne Tvicok

      ; ### Si probleme message d'avertissement
      invoke MessageBox,hWnd,ADDR messageerioport,ADDR szDisplayName,MB_YESNO
      cmp eax,IDYES
      jne ExitLoop 

      Tvicok:
      invoke SetHardAccess,0 ;acces indirect

;calcule de la taille de la fenetre

 invoke GetSystemMetrics,SM_CXSIZEFRAME
 lea ebx,[SCREEN_WIDTH+eax+eax]
 
 invoke GetSystemMetrics,SM_CYSIZEFRAME
 lea edi,[SCREEN_HEIGHT+eax+eax]

 invoke GetSystemMetrics,SM_CYCAPTION
 add edi,eax

 invoke GetSystemMetrics,SM_CYMENU
 add edi,eax

 invoke GetSystemMetrics,SM_CYBORDER
 add edi,eax
 sub edi,3 ; !FIXME
 sub ebx,2

 invoke CreateWindowEx,WS_EX_LEFT,ADDR szClassName,ADDR szDisplayName,WS_OVERLAPPED or WS_SYSMENU,16,16,ebx,edi,NULL,NULL,hInst,NULL

 mov   hWnd,eax

 invoke LoadMenu,hInst,600  ; menu ID
 invoke SetMenu,hWnd,eax

 invoke ShowWindow,hWnd,SW_SHOWNORMAL
 invoke UpdateWindow,hWnd

 ;#Creation thread image background
 invoke CreateThread,NULL,MAIN_THREAD_STACKSIZE_KB*1024,ADDR MainLoopProc,hWnd,NULL,ADDR MainThreadHandle

 invoke SetTimer,hWnd,1,10,NULL
 invoke SetTimer,hWnd,2,500,offset rafraichir

 invoke GetMenu,hWnd
 mov hMenu,eax
 invoke EnableMenuItem,hMenu,1906,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,1905,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,1907,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,1908,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,1909,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,3378,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,3278,MF_BYCOMMAND or MF_ENABLED
 invoke EnableMenuItem,hMenu,3399,MF_BYCOMMAND or MF_ENABLED

      invoke CheckMenuItem,hMenu,1905,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,1906,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,1907,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,1908,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,1909,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3378,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_UNCHECKED or MF_BYCOMMAND

;###Detection interface 
LoopDetecte:
 call CHECKPRESENCE
 cmp al,1
je StartLoop21

szText TheText2,"Interface non dtect !!!"
invoke MessageBox,hWnd,ADDR TheText2,ADDR szDisplayName,MB_ABORTRETRYIGNORE

 cmp eax,IDABORT
je ExitLoop
 cmp eax,IDRETRY
je LoopDetecte
jmp StartLoop

StartLoop21:
 CALL FASTCOPYBANK0 ; copie de l'entete cartouche dans le buffer
 call CHECKLOGO     ; verification logo NINTENDO
 cmp al,1
jne StartLoop

 mov dl,0
 CALL AjouteNomCartouche ; affichage du nom de la cartouche 

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================

  StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop

      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg

      jmp StartLoop

ExitLoop:
   call SHUTDOWNINTERF ; Arret de l'interface
   invoke PostMessage,hWnd,WM_CLOSE,NULL,NULL
   invoke CloseTVicPort
   return msg.wParam
WinMain endp

;### Copie buffer -> Ecran
DIB_Draw PROC hWndb:HWND
LOCAL myRect:RECT
 invoke GetClientRect,hWndb,ADDR myRect
 mov edx,0
 invoke StretchDIBits,myDC,edx,edx,
                      myRect.right,
                      myRect.bottom,
                      edx,edx,
                      SCREEN_WIDTH,
                      SCREEN_HEIGHT,
                      OFFSET FrameBuffer,
                      ADDR dibinf,
                      edx,        ;DIB_RGB_COLORS=0
                      SRCCOPY
 ret
DIB_Draw ENDP

;### Palette 
;BGRx for Win
CalcPalette PROC
 mov edi,OFFSET Win_Palette
 mov esi,OFFSET dessin + 36h
 mov ecx,256
@@boucle022:
 mov al,ds:[esi]
 mov ds:[edi],al
 mov al,ds:[esi+1]
 mov ds:[edi+1],al
 mov al,ds:[esi+2]
 mov ds:[edi+2],al
 add edi,4
 add esi,4
 dec ecx
 jnz @@boucle022
 ret
CalcPalette ENDP

; #########################################################################

ALIGN 4
;/////////////////////Tread principal
WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL hDC    :DWORD
    LOCAL Ps     :PAINTSTRUCT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    .if uMsg == WM_COMMAND


    ;======== menu commands ========
        .if wParam == 1010
         invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

        .elseif wParam == 1900 ;////////// About 
        invoke MessageBox,hWnd,ADDR AboutMsg,ADDR szDisplayName,MB_OK

         .elseif wParam == 1901 ;/////////Menu Detection ......
         mov ds:[Transfer],0ffh
         mov al,ds:[detectauto]
         push ax
         mov al,0ffh
         mov ds:[detectauto],al
         call CHECKPRESENCE
         cmp al,1
         je okjp456
            szText TheText4,"Interface non dtect!!!"
            invoke MessageBox,hWin,ADDR TheText4,ADDR szDisplayName,MB_OK
            jmp finjp456
          okjp456:
          szText TheText5,"Interface dtect..."
            invoke MessageBox,hWin,ADDR TheText5,ADDR szDisplayName,MB_OK
            finjp456:
            pop ax
            mov ds:[detectauto],al
            mov ds:[Transfer],0h

         .elseif wParam == 1310 ;///////////Cartouche->Fichier

          mov ds:[Transfer],0ffh

          Loop0202:

          call CHECKPRESENCE
          cmp al,1
          je oksuitebffff

          szText TheText7,"Interface non Prsente!!!"
          invoke MessageBox,hWin,ADDR TheText7,ADDR szDisplayName,MB_OK
          jmp finloadcart

          oksuitebffff:
          call COPYBANK0
          call CHECKLOGO
          cmp al,1
          je oksuiteafff
          szText TheText6,"Cartouche Nintendo non prsente!!!"
          invoke MessageBox,hWin,ADDR TheText6,ADDR szDisplayName,MB_OK
          jmp finloadcart

          oksuiteafff:
          ;invoke MessageBox,hWin,Offset BufferCartouche1 + 134h,ADDR szDisplayName,MB_OK
          XOR CX,CX
          mov ds:[tempword],CX

          mov dl,1
          Call AjouteNomCartouche ;dl=1>nomfichaussi

          Call OuvertureFichier
          cmp eax,0
          jne ERREURFINSW3

          call CHECKSUMBANK0

          mov esi,offset BufferCartouche1
          call EcrisBank

          Call GetNombreDeBlock
          mov ds:[compteurbloque],al

          mov al,1
          mov ds:[compteurbloque2],al

          call InitChangeNumBank
       
         xor ax,ax
         mov al,ds:[compteurbloque]
         call ChangeNumBank

         mov al,ds:[compteurbloque2]
         call ChangeBank

        boucleecriture:
        call COPYBANK1
        call CHECKSUMBANK1

        mov esi,offset BufferCartouche2
        call EcrisBank

        call ChangeNumBank

        dec  ds:[compteurbloque]
        inc  ds:[compteurbloque2]

        mov  al,ds:[compteurbloque2]
        call ChangeBank

        cmp  byte ptr ds:[compteurbloque],1
        jne  boucleecriture

        call CloseChangeNumBank

        mov cx,ds:[tempword]
        mov esi,offset BufferCartouche1 + 14eh
        mov dx,ds:[esi]
        ROR dx,8
        cmp cx,dx
        jne fin456456

        szText TheText9,"Copie de la Cartouche termine..."
        invoke MessageBox,hWin,ADDR TheText9,ADDR szDisplayName,MB_OK
        jmp fin54512156

        fin456456:
        invoke CloseHandle,hFile
        szText TheText8,"Checksum error!!!! Recommencer?"
        invoke MessageBox,hWin,ADDR TheText8,ADDR szDisplayName,MB_YESNO
        cmp eax,IDYES
        je Loop0202

        jmp ERREURFINSW3

fin54512156:

         invoke CloseHandle,hFile

         mov ds:[Transfer],0h

         ERREURFINSW3:
         mov ds:[Transfer],0h
         finloadcart:
         mov ds:[Transfer],0h




     .elseif wParam == 1312 ;/////////////////checksum cartouche
         mov ds:[Transfer],0ffh

            Loop0202b:

             xor cx,cx
             mov ds:[tempword],cx

             call CHECKPRESENCE
             cmp al,1
             je oksuitebffffb
             invoke MessageBox,hWin,ADDR TheText7,ADDR szDisplayName,MB_OK
             jmp finloadcartb

             oksuitebffffb:
             call COPYBANK0
             call CHECKLOGO
             cmp al,1
             je oksuiteafffb
             invoke MessageBox,hWin,ADDR TheText6,ADDR szDisplayName,MB_OK
             jmp finloadcartb

            oksuiteafffb:
             mov dl,0
             call AjouteNomCartouche

             call CHECKSUMBANK0
     
            Call GetNombreDeBlock
            mov ds:[compteurbloque],al

            mov al,1
            mov ds:[compteurbloque2],al

            call InitChangeNumBank

            xor ax,ax
            mov al,ds:[compteurbloque]
            call ChangeNumBank

            mov al, ds:[compteurbloque2]
            call ChangeBank

            boucleecritureb:
            call COPYBANK1
            call CHECKSUMBANK1

            call ChangeNumBank

        dec  ds:[compteurbloque]

        inc  ds:[compteurbloque2]
        mov  al,ds:[compteurbloque2]
        call ChangeBank

        cmp  byte ptr ds:[compteurbloque],1
        jne  boucleecritureb

        call CloseChangeNumBank

        mov cx,ds:[tempword]
        mov esi,offset BufferCartouche1 + 14eh
        mov dx,ds:[esi]
        ROR dx,8
        cmp cx,dx
        jne fin456456b

        szText TheText10,"CheckSum Ok....."
        invoke MessageBox,hWin,ADDR TheText10,ADDR szDisplayName,MB_OK
        jmp fin54512156b

        fin456456b:

        invoke CloseHandle,hFile
        szText TheText11,"Checksum error!!!! Recommencer?"
        invoke MessageBox,hWin,ADDR TheText11,ADDR szDisplayName,MB_YESNO
        cmp eax,IDYES
        je Loop0202b
        jmp finloadcartb

fin54512156b:
finloadcartb:

       mov ds:[Transfer],0h

     .elseif wParam == 1902
         mov ds:[Transfer],0ffh

     call CHECKPRESENCE
     cmp al,1
     je oksuitebffffc
     invoke MessageBox,hWin,ADDR TheText7,ADDR szDisplayName,MB_OK
     jmp finloadcartc
     oksuitebffffc:
     CALL FASTCOPYBANK0
     call CHECKLOGO
     cmp al,1
     je oksuiteafffc
     ;szText TheText6,"Cartouche Nintendo non prsente!!!"
     invoke MessageBox,hWin,ADDR TheText6,ADDR szDisplayName,MB_OK
     jmp finloadcartc
     oksuiteafffc:

      xor dx,dx
      call AjouteNomCartouche
      infoaffichebloc:
      call InfoBox


    finloadcartc:
       mov ds:[Transfer],0h

     .elseif wParam  == 1600   ;///////////Sauvegarde->Fichier

          mov ds:[Transfer],0ffh
          mov ax,8*1024
          mov ds:[sizebanksram],ax

          Loop0202sav:

          call CHECKPRESENCE
          cmp al,1
          je oksuitebffffsav

          invoke MessageBox,hWin,ADDR TheText7,ADDR szDisplayName,MB_OK
          jmp finloadcart

          oksuitebffffsav:
          call COPYBANK0
          call CHECKLOGO
          cmp al,1
          je oksuiteafffsav
          invoke MessageBox,hWin,ADDR TheText6,ADDR szDisplayName,MB_OK
          jmp finloadcartsav

          oksuiteafffsav:        
          ;invoke MessageBox,hWin,Offset BufferCartouche1 + 134h,ADDR szDisplayName,MB_OK
          XOR CX,CX
          mov ds:[tempword],CX

          mov dl,1
          Call AjouteNomCartouche2 ;dl=1>nomfichaussi
           mov ds:[FilterStringAdr],offset FilterString2
          Call OuvertureFichier
          cmp eax,0
          jne ERREURFINSW3sav

          call UNLOCKSRAM

          Call GetNombreDeBlockSram
          cmp al,0
          jne suitelkfdldf
          szText TheText91sav,"Cette cartouche ne contient pas de Sram!!!"
          invoke MessageBox,hWin,ADDR TheText91sav,ADDR szDisplayName,MB_OK
          jmp ERREURFINSW3sav

          suitelkfdldf:
          cmp al,255
          jne kdkdkdkdks
          mov ax,4*1024
          mov ds:[sizebanksram],ax
          mov ax,1
          kdkdkdkdks:

          mov ds:[compteurbloque],al

          mov al,0
          mov ds:[compteurbloque2],al
              
          call InitChangeNumBank
       
         xor ax,ax
         mov al,ds:[compteurbloque]
         call ChangeNumBank

         mov al,ds:[compteurbloque2]
         call ChangeBankSram

        boucleecrituresav:
        call COPYSRAMBANK

        mov esi,offset BufferCartouche2
        call EcrisBankSram

        call ChangeNumBank

        dec  ds:[compteurbloque]
        inc  ds:[compteurbloque2]

        mov  al,ds:[compteurbloque2]
        call ChangeBankSram

        cmp  byte ptr ds:[compteurbloque],0
        jne  boucleecrituresav

       call LOCKSRAM

        call CloseChangeNumBank


        szText TheText9sav,"Copie de la sauvegarde termine..."
        invoke MessageBox,hWin,ADDR TheText9sav,ADDR szDisplayName,MB_OK


         mov ds:[Transfer],0h

         ERREURFINSW3sav:

         mov ds:[Transfer],0h
         finloadcartsav:
         mov ds:[Transfer],0h
         mov ds:[FilterStringAdr],offset FilterString
         invoke CloseHandle,hFile

     .elseif wParam  == 1601  ;///////////Fichier->Sauvegarde
          mov ds:[Transfer],0ffh

          mov ax,8*1024
          mov ds:[sizebanksram],ax
          
          Loop0202savb:

          call CHECKPRESENCE
          cmp al,1
          je oksuitebffffsavb

          invoke MessageBox,hWin,ADDR TheText7,ADDR szDisplayName,MB_OK
          jmp finloadcartb


          oksuitebffffsavb:
          call COPYBANK0
          call CHECKLOGO
          cmp al,1
          je oksuiteafffsavb
          invoke MessageBox,hWin,ADDR TheText6,ADDR szDisplayName,MB_OK
          jmp finloadcartsavb

          oksuiteafffsavb:        
          ;invoke MessageBox,hWin,Offset BufferCartouche1 + 134h,ADDR szDisplayName,MB_OK
          XOR CX,CX
          mov ds:[tempword],CX

          mov dl,1
          Call AjouteNomCartouche2 ;dl=1>nomfichaussi

          call UNLOCKSRAM

          mov ds:[FilterStringAdr],offset FilterString2
          Call OuvertureFichierl
          cmp eax,0
          jne ERREURFINSW3savb


          Call GetNombreDeBlockSram
          cmp al,0
          jne suitelkfdldfs
          invoke MessageBox,hWin,ADDR TheText91sav,ADDR szDisplayName,MB_OK
          jmp ERREURFINSW3savb
          suitelkfdldfs:
          cmp al,255
          jne kdkdkdkdk
          mov ax,4*1024
          mov ds:[sizebanksram],ax
          mov ax,1
          kdkdkdkdk:
          mov ds:[compteurbloque],al

          mov al,0
          mov ds:[compteurbloque2],al
              
          call InitChangeNumBank
       
         xor ax,ax
         mov al,ds:[compteurbloque]
         call ChangeNumBank

         mov al,ds:[compteurbloque2]
         call ChangeBankSram

        boucleecrituresavb:
        mov esi, offset BufferCartouche2
        call LireBankSram


             Mov BX,0a000h
             MOV ESI,OFFSET BufferCartouche2
             Boucleecris2bank1sav:
             mov al,ds:[esi]
             MOV DH,200
             MOV CH,AL
             Boucleecris2bank1vsav:
             mov al,ch
             xor cl,cl
             CALL ECRISCAR
             CALL LECTURECARSRAM
             CMP AL,ch
             JE SUITEOKBOUCLEECRISB2sav
             DEC DH
             jnz Boucleecris2bank1vsav
             jmp erreurwri01sav
             SUITEOKBOUCLEECRISB2sav:
             inc esi
             inc bx
             cmp bx,0c000h
             jne Boucleecris2bank1sav

        mov al,ds:[compteurbloque]
        call ChangeNumBank

        dec  ds:[compteurbloque]
        inc  ds:[compteurbloque2]

        mov  al,ds:[compteurbloque2]
        call ChangeBankSram

        cmp  byte ptr ds:[compteurbloque],0
        jne  boucleecrituresavb
        ijhkhnjjjjjjjjjjjjjjjjk:
        call LOCKSRAM

        call CloseChangeNumBank


        szText TheText9savb,"Ecriture de la sauvegarde termine..."
        invoke MessageBox,hWin,ADDR TheText9savb,ADDR szDisplayName,MB_OK

        ; invoke CloseHandle,hFile

         mov ds:[Transfer],0h
         jmp finsdfddffdfd
         erreurwri01sav:
        szText TheText9savbe,"Erreur d'ecriture!"
        invoke MessageBox,hWin,ADDR TheText9savbe,ADDR szDisplayName,MB_OK

         ERREURFINSW3savb:
         mov ds:[Transfer],0h
         finloadcartsavb:
         mov ds:[Transfer],0h
          finsdfddffdfd:
          mov ds:[FilterStringAdr],offset FilterString
         invoke CloseHandle,hFile
          

     .elseif wParam  == 1800  ;///////////Rafraichir
      mov ds:[Transfer],0ffh

     call CHECKPRESENCE
     cmp al,1
     je oksuitebffffd
     xor al,al
     mov ds:[DisplayName],al

     jmp finloadcartd
     oksuitebffffd:
     CALL FASTCOPYBANK0
     call CHECKLOGO
     cmp al,1
     je oksuiteafffd
     xor al,al
     mov ds:[DisplayName],al
     jmp finloadcartd
     oksuiteafffd:

             mov dl,0
             call AjouteNomCartouche

             finloadcartd:
             invoke SetWindowText,hWnd,ADDR szDisplayName
             mov ds:[Transfer],0h

    .elseif wParam  == 1311   ;/////////////Fichier -> Cartouche
        Loop0203:
           mov ds:[Transfer],0ffh
           ;mov ds:[MCBNORM],0ffh
           call InitChangeNumBank

           call OuvertureFichierl
           cmp eax,0
           JNE ERREURFINSW3b

            mov esi, offset BufferCartouche1
            call LireBank
            call CHECKLOGO
            cmp al,1
            je oksuiteafsff

            szText TheText13,"Ce n`est pas une Rom Game Boy!!!"
            invoke MessageBox,hWin,ADDR TheText13,ADDR szDisplayName,MB_OK
            jmp ERREURFINSW3b

             oksuiteafsff:

             mov ds:[compteurbloque],0
             xor eax,eax
             mov al,ds:[BufferCartouche1 + 148h]
             cmp al,0
             je s6578954p
             cmp ds:[MCBNORM2],0
             jne s6578954p
             szText TheText33,"Erreur: ",13,10,"La cartouche de SRAM 32K supporte des roms de 32Ko MAX !"
             invoke MessageBox,hWin,ADDR TheText33,ADDR szDisplayName,MB_OK
             jmp ERREURFINSW3b

             s6578954p:
             Call GetNombreDeBlock
             mov ds:[compteurbloque2],al

             call CHECKPRESENCE
             cmp al,1
             je oksuitebffffcds

             invoke MessageBox,hWin,ADDR TheText7,ADDR szDisplayName,MB_OK
             jmp ERREURFINSW3b

             oksuitebffffcds:

             mov esi,offset BufferCartouche2
             call LireBank

             XOR BX,BX
             MOV ESI,OFFSET BufferCartouche1
             Boucleecris2bank1:
             mov al,ds:[esi]
             MOV DH,200
             MOV CH,AL

             Boucleecris2bank1v:
             mov al,ch

             CMP DS:[MCBNORM2],0
             JE IORGIRD
             CALL ECRISCAR2
             JMP SSDGJKLHDFJKG414
             IORGIRD:
             MOV CL,1
             CALL ECRISCAR
             SSDGJKLHDFJKG414:
             CALL LECTURECAR
             CMP AL,ch
             JE SUITEOKBOUCLEECRISB2
             DEC DH
             jnz Boucleecris2bank1v
             jmp erreurwri01
             SUITEOKBOUCLEECRISB2:
             inc esi
             inc bx
             cmp bx,4000h
             jne Boucleecris2bank1

             CMP DS:[MCBNORM2],0
             JE S45464SFD
             inc  ds:[compteurbloque]

             mov al,ds:[compteurbloque]
             call ChangeBank
             call ChangeNumBank

             S45464SFD:
             call ChangeNumBank

             Boucleecrisbank1:
             MOV ESI,OFFSET BufferCartouche2
             mov bx,4000h

             Boucleecris2bank1b:
             mov al,ds:[esi]
             MOV DH,200
             mov ch,al
             Boucleecris2bank1vb:
             mov al,ch
             CMP DS:[MCBNORM2],0
             JE IORGIRD2
             CALL ECRISCAR2
             JMP SSDGJKLHDFJKG4142
             IORGIRD2:
             MOV CL,1
             CALL ECRISCAR
             SSDGJKLHDFJKG4142:
             CALL LECTURECAR
             CMP AL,ch
             JE SUITEOKBOUCLEECRISB2b
             DEC DH
             jnz Boucleecris2bank1vb
             jmp erreurwri01
             SUITEOKBOUCLEECRISB2b:
             inc esi
             inc bx
             cmp bx,8000h
             jne Boucleecris2bank1b


             cmp ds:[compteurbloque2],2
             je  finicopiecar001
             inc  ds:[compteurbloque]
             call ChangeNumBank


          CMP DS:[MCBNORM2],0
          JE finicopiecar001

          mov  al,ds:[compteurbloque]
          call ChangeBank
          mov esi,offset BufferCartouche2
          call LireBank
          mov bx,4000h
          mov al,ds:[compteurbloque2]
          cmp al,ds:[compteurbloque]
          jne Boucleecrisbank1

          jmp finicopiecar001

    erreurwri02:
        invoke CloseHandle,hFile
        szText TheText16,"Erreur de CheckSum!!! Recommencer ?"
        invoke MessageBox,hWin,ADDR TheText16,ADDR szDisplayName,MB_YESNO
        cmp eax,IDYES
        je Loop0203
     jmp ERREURFINSW3bc

    erreurwri01:
        invoke CloseHandle,hFile
        szText TheText14,"Erreur d`ecriture sur cartouche!!! Recommencer ?"
        invoke MessageBox,hWin,ADDR TheText14,ADDR szDisplayName,MB_YESNO
        cmp eax,IDYES
        je Loop0203
     jmp ERREURFINSW3bc

    finicopiecar001:
        call COPYBANK0
        call COPYBANK1

        CMP DS:[MCBNORM2],0
        JNE S45464SFD2

        call CHECKSUMBANK0
        call CHECKSUMBANK1
        mov cx,ds:[tempword]
        mov esi,offset BufferCartouche1 + 14eh
        mov dx,ds:[esi]
        ROR dx,8
        cmp cx,dx
        jne erreurwri02
        szText TheText77,"Cartouche Programme",10,13,\
        "protegez en criture la cartouche et retirez-la de l`interface..."

        invoke MessageBox,hWin,ADDR TheText77,ADDR szDisplayName,MB_OK
        jmp finecrisdd2123
        S45464SFD2:
        szText TheText15,"Cartouche Programme..."
        invoke MessageBox,hWin,ADDR TheText15,ADDR szDisplayName,MB_OK

        call CloseChangeNumBank


         call CHECKLOGO
         cmp al,1
         jne erreurwri01
      ;  xor dx,dx
        call AjouteNomCartouche
        invoke CloseHandle,hFile
        JMP Loop0202b
      finecrisdd2123:
        call CloseChangeNumBank
        invoke CloseHandle,hFile

        mov ds:[Transfer],0h

     ERREURFINSW3b:
         mov ds:[Transfer],0h

         invoke CloseHandle,hFile
     ERREURFINSW3bc:
         mov ds:[Transfer],0h


    .elseif wParam  == 1313  ;///////////checksum fichier
             Loop0204:
                call OuvertureFichierl
                CMP EAX,0
                JNE ERREURFINSW3bt

             invoke ReadFile,hFile,ADDR BufferCartouche1,16*1024,ADDR sizewri,NULL
             call CHECKLOGO
             cmp al,1
             je oksuiteafsfft
             invoke MessageBox,hWin,ADDR TheText13,ADDR szDisplayName,MB_OK
             jmp ERREURFINSW3bt
             oksuiteafsfft:

        call CHECKSUMBANK0

        call GetNombreDeBlock
        mov ds:[compteurbloque],al
        mov al,1
        mov ds:[compteurbloque2],al

        boucleecriturecheckf:
        invoke ReadFile,hFile,ADDR BufferCartouche2,16*1024,ADDR sizewri,NULL
        call CHECKSUMBANK1
        dec  ds:[compteurbloque]
        inc  ds:[compteurbloque2]
        cmp  byte ptr ds:[compteurbloque],1
        jne  boucleecriturecheckf

        mov cx,ds:[tempword]
        mov esi,offset BufferCartouche1 + 14eh
        mov dx,ds:[esi]
        ROR dx,8
        cmp cx,dx
        jne fin456456t

        invoke CloseHandle,hFile
        szText TheText18,"CheckSum fichier ok...  Un autre fichier ?"
        invoke MessageBox,hWin,ADDR TheText18,ADDR szDisplayName,MB_YESNO
        cmp eax,IDYES
        je Loop0204
        jmp fin54512156t

        fin456456t:

        invoke CloseHandle,hFile
        szText TheText19,"Checksum error!!!! Un autre fichier ?"
        invoke MessageBox,hWin,ADDR TheText19,ADDR szDisplayName,MB_YESNO
        cmp eax,IDYES
        je Loop0204
        jmp ERREURFINSW3bt

         ERREURFINSW3bt:
         invoke CloseHandle,hFile
fin54512156t:

    .elseif wParam  == 1903 ;//////Info Fichier

       Loop1215:
                call OuvertureFichierl
                CMP EAX,0
                JNE ERREURFINSW3btz
         invoke ReadFile,hFile,ADDR BufferCartouche1,16*1024,ADDR sizewri,NULL
         call CHECKLOGO
          cmp al,1
          je oksuiteafsfftz
           invoke MessageBox,hWin,ADDR TheText13,ADDR szDisplayName,MB_OK
           jmp ERREURFINSW3btzg
           oksuiteafsfftz:
           invoke CloseHandle,hFile
           jmp infoaffichebloc

        ERREURFINSW3btzg:
        invoke CloseHandle,hFile
        jmp Loop1215
         ERREURFINSW3btz:

    .elseif wParam  == 1904 ;///////Liste des codes
   invoke MessageBox,hWin,ADDR infomsg,ADDR szDisplayName,MB_OK
   invoke MessageBox,hWin,ADDR infomsg2,ADDR szDisplayName,MB_OK

    .elseif wParam  == 1905
      invoke CheckMenuItem,hMenu,1905,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,1906,MF_UNCHECKED or MF_BYCOMMAND
      MOV DS:[MCBNORM2],0
      MOV DS:[MCBNORM],0H

    .elseif wParam  == 1906
      invoke CheckMenuItem,hMenu,1906,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,1905,MF_UNCHECKED or MF_BYCOMMAND
      MOV DS:[MCBNORM2],0FFH
      MOV DS:[MCBNORM],0FFH
    .elseif wParam  == 1907
      invoke TestHardAccess
      cmp eax,0
      jne softaccess
      hardaccess:
      invoke SetHardAccess,1
      invoke CheckMenuItem,hMenu,1907,MF_CHECKED or MF_BYCOMMAND
      jmp finaccess
      softaccess:
      invoke SetHardAccess,0
      invoke CheckMenuItem,hMenu,1907,MF_UNCHECKED or MF_BYCOMMAND
      finaccess:
    .elseif wParam  == 1909
      not ds:[Rafraichissement]
      mov al,ds:[Rafraichissement]
      cmp al,0
      jz rafraichioff
      rafraichion:
      invoke CheckMenuItem,hMenu,1909,MF_CHECKED or MF_BYCOMMAND
      jmp finrafrai
      rafraichioff:
      invoke CheckMenuItem,hMenu,1909,MF_UNCHECKED or MF_BYCOMMAND
      finrafrai:
    .elseif wParam  == 1908
      not ds:[detectauto]
      mov al,ds:[detectauto]
      cmp al,0
      jz dectectautomaoff
      dectectautomaon:
      invoke CheckMenuItem,hMenu,1908,MF_CHECKED or MF_BYCOMMAND
      jmp findectectautoma
      dectectautomaoff:
      invoke CheckMenuItem,hMenu,1908,MF_UNCHECKED or MF_BYCOMMAND
      findectectautoma:
    .elseif wParam  == 3378
      mov ds:[PPORT],378h
      invoke CheckMenuItem,hMenu,3378,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_UNCHECKED or MF_BYCOMMAND
    .elseif wParam  == 3278
      mov ds:[PPORT],278h
      invoke CheckMenuItem,hMenu,3378,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_CHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_UNCHECKED or MF_BYCOMMAND
    .elseif wParam  == 3399
      mov ds:[PPORT],3bch
      invoke CheckMenuItem,hMenu,3378,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3278,MF_UNCHECKED or MF_BYCOMMAND
      invoke CheckMenuItem,hMenu,3399,MF_CHECKED or MF_BYCOMMAND

    .endif

    ;====== end menu commands ======
    .elseif uMsg == WM_TIMER
      mov eax,0ffffffffh
      mov    ds:[UpdateInfo],eax
      return 0

    .elseif uMsg == WM_CREATE

    .elseif uMsg == WM_SIZE

    .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWin,ADDR Ps
          mov hDC, eax
          invoke Paint_Proc,hWin,hDC
        invoke EndPaint,hWin,ADDR Ps
        return 0

    .elseif uMsg == WM_CLOSE
        szText TheText,"Voulez-vous vraiment sortir ?"
        invoke MessageBox,hWin,ADDR TheText,ADDR szDisplayName,MB_YESNO
          .if eax == IDNO
            return 0
          .endif

    .elseif uMsg == WM_DESTROY
        invoke PostQuitMessage,NULL
        return 0 
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; #########################################################################

Paint_Proc proc hWin:DWORD, hDC:DWORD

    LOCAL btn_hi   :DWORD
    LOCAL btn_lo   :DWORD
    LOCAL Rct      :RECT

    invoke GetSysColor,COLOR_BTNHIGHLIGHT
    mov btn_hi, eax

    invoke GetSysColor,COLOR_BTNSHADOW
    mov btn_lo, eax

    return 0

Paint_Proc endp

; ########################################################################

end start
